/*
 * A n t l r  T r a n s l a t i o n  H e a d e r
 *
 * Terence Parr, Will Cohen, and Hank Dietz: 1989-2001
 * Purdue University Electrical Engineering
 * With AHPCRC, University of Minnesota
 * ANTLR Version 1.33MR29
 *
 *   d:\pccts_now\pccts\bin\antlr.exe -CC -ck 2 -prc on -mrhoist on ansi.g
 *
 */

#define ANTLR_VERSION	13329
#include "pcctscfg.h"
#include "pccts_stdio.h"
#include "tokens.h"

#include "CDictionary.h"

#ifdef WIN32
#pragma warning(disable:4102) /* Unreferced labels */
#endif

  
#include "AParser.h"
#include "CParser.h"
#include "DLexerBase.h"
#include "ATokPtr.h"

/* MR23 In order to remove calls to PURIFY use the antlr -nopurify option */

#ifndef PCCTS_PURIFY
#define PCCTS_PURIFY(r,s) memset((char *) &(r),'\0',(s));
#endif


typedef ANTLRCommonToken ANTLRToken;

void
CParser::translation_unit(void)
{
  zzRULE;
  enterExternalScope();
  {
    int zzcnt=1;
    do {
      external_declaration();
    } while ( (setwd1[LA(1)]&0x1) );
  }
  zzmatch(Eof);
  if ( !guessing ) {
  exitExternalScope();
  }
 consume();
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd1, 0x2);
}

void
CParser::external_declaration(void)
{
  zzRULE;
  zzGUESS_BLOCK
  zzGUESS
  if ( !zzrv && (setwd1[LA(1)]&0x4) && (setwd1[LA(2)]&0x8) ) {
    {
      {
        if ( (setwd1[LA(1)]&0x10) && (setwd1[LA(2)]&0x20)&&(!(((LA(1)==IDENTIFIER)))||(isTypeName(LT(1)->getText()))) ) {
          declaration_specifiers();
        }
        else {
          if ( (setwd1[LA(1)]&0x40) && 
(setwd1[LA(2)]&0x80) ) {
          }
          else {FAIL(2,err1,err2,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
        }
      }
      declarator();
      {
        if ( (setwd2[LA(1)]&0x1) ) {
          declaration_list();
        }
        else {
          if ( (LA(1)==LCURLYBRACE) ) {
            zzmatch(LCURLYBRACE); consume();
          }
          else {FAIL(1,err3,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
        }
      }
    }
    zzGUESS_DONE
    function_definition();
  }
  else {
    if ( !zzrv ) zzGUESS_DONE;
    if ( (setwd2[LA(1)]&0x2) && (setwd2[LA(2)]&0x4) ) {
      declaration();
    }
    else {FAIL(2,err4,err5,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd2, 0x8);
}

void
CParser::function_definition(void)
{
  zzRULE;
  ;
  if ( !guessing ) {
  beginFunctionDefinition();
  }
  {
    if ( (setwd2[LA(1)]&0x10) && (setwd2[LA(2)]&0x20)&&(!(((LA(1)==IDENTIFIER)
))||(isTypeName(LT(1)->getText()))) ) {
      declaration_specifiers();
    }
    else {
      if ( (setwd2[LA(1)]&0x40) && (setwd2[LA(2)]&0x80) ) {
      }
      else {FAIL(2,err6,err7,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
    }
  }
  declarator();
  {
    if ( (setwd3[LA(1)]&0x1) ) {
      declaration_list();
    }
    else {
      if ( (LA(1)==LCURLYBRACE) ) {
      }
      else {FAIL(1,err8,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
    }
  }
  compound_statement();
  if ( !guessing ) {
  endFunctionDefinition();
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd3, 0x2);
}

void
CParser::declaration(void)
{
  zzRULE;
  beginDeclaration();
  declaration_specifiers();
  {
    if ( (setwd3[LA(1)]&0x4) ) {
      init_declarator_list();
    }
    else {
      if ( (LA(1)==SEMICOLON)
 ) {
      }
      else {FAIL(1,err9,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
    }
  }
  zzmatch(SEMICOLON);
  if ( !guessing ) {
  endDeclaration();
  }
 consume();
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd3, 0x8);
}

void
CParser::declaration_list(void)
{
  zzRULE;
  {
    int zzcnt=1;
    if ((!(((LA(1)==IDENTIFIER)))||(isTypeName(LT(1)->getText())))) {
    do {
      declaration();
    } while ( (setwd3[LA(1)]&0x10)&&(!(((LA(1)==IDENTIFIER)))||(isTypeName(LT(1)->getText()))) );
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd3, 0x20);
}

void
CParser::declaration_specifiers(void)
{
  zzRULE;
  
  TypeSpecifier ts = tsINVALID,ts2;
  TypeQualifier tq = tqINVALID,tq2;
  StorageClass  sc = scINVALID;
  {
    int zzcnt=1;
    ;
    do {
      if ( (setwd3[LA(1)]&0x40) ) {
        if ( !guessing ) {
        if (sc!=scINVALID) synError("multiple storage classes", LT(1));
        }
        if ( !guessing ) {
           sc  = storage_class_specifier();

        } else {
          storage_class_specifier();
        }
      }
      else {
        if ( (setwd3[LA(1)]&0x80) && 
(setwd4[LA(2)]&0x1)&&(!(((LA(1)==IDENTIFIER)))||(isTypeName(LT(1)->getText()))) ) {
          if ( !guessing ) {
             ts2  = type_specifier();

          } else {
            type_specifier();
          }
          if ( !guessing ) {
          ts=checkTypeSpecifier(ts, ts2, LT(1));
          }
        }
        else {
          if ( (setwd4[LA(1)]&0x2) ) {
            if ( !guessing ) {
               tq2  = type_qualifier();

            } else {
              type_qualifier();
            }
            if ( !guessing ) {
            if (tq&tq2) synError("multiple type qualifier", LT(1)); else tq=TypeQualifier(tq|tq2);
            }
          }
          /* MR10 ()+ */ else {
            if ( zzcnt > 1 ) break;
            else {FAIL(2,err10,err11,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
          }
        }
      }
      zzcnt++;
    } while ( 1 );
  }
  if ( !guessing ) {
  declarationSpecifier(sc, tq, ts);
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd4, 0x4);
}

CParser::StorageClass
CParser::storage_class_specifier(void)
{
  CParser::StorageClass   _retv;
  zzRULE;
  PCCTS_PURIFY(_retv,sizeof(CParser::StorageClass  ))
  if ( (LA(1)==AUTO) ) {
    zzmatch(AUTO);
    if ( !guessing ) {
    _retv = scAUTO;
    }
 consume();
  }
  else {
    if ( (LA(1)==REGISTER) ) {
      zzmatch(REGISTER);
      if ( !guessing ) {
      _retv = scREGISTER;
      }
 consume();
    }
    else {
      if ( (LA(1)==STATIC)
 ) {
        zzmatch(STATIC);
        if ( !guessing ) {
        _retv = scSTATIC;
        }
 consume();
      }
      else {
        if ( (LA(1)==EXTERN) ) {
          zzmatch(EXTERN);
          if ( !guessing ) {
          _retv = scEXTERN;
          }
 consume();
        }
        else {
          if ( (LA(1)==TYPEDEF) ) {
            zzmatch(TYPEDEF);
            if ( !guessing ) {
            _retv = scTYPEDEF;
            }
 consume();
          }
          else {FAIL(1,err12,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
        }
      }
    }
  }
  return _retv;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd4, 0x8);
  return _retv;
}

CParser::TypeSpecifier
CParser::type_specifier(void)
{
  CParser::TypeSpecifier   _retv;
  zzRULE;
  PCCTS_PURIFY(_retv,sizeof(CParser::TypeSpecifier  ))
  if ( (LA(1)==VOID) ) {
    zzmatch(VOID);
    if ( !guessing ) {
    _retv = tsVOID;
    }
 consume();
  }
  else {
    if ( (LA(1)==CHAR) ) {
      zzmatch(CHAR);
      if ( !guessing ) {
      _retv = tsCHAR;
      }
 consume();
    }
    else {
      if ( (LA(1)==SHORT)
 ) {
        zzmatch(SHORT);
        if ( !guessing ) {
        _retv = tsSHORT;
        }
 consume();
      }
      else {
        if ( (LA(1)==INT) ) {
          zzmatch(INT);
          if ( !guessing ) {
          _retv = tsINT;
          }
 consume();
        }
        else {
          if ( (LA(1)==LONG) ) {
            zzmatch(LONG);
            if ( !guessing ) {
            _retv = tsLONG;
            }
 consume();
          }
          else {
            if ( (LA(1)==FLOAT) ) {
              zzmatch(FLOAT);
              if ( !guessing ) {
              _retv = tsFLOAT;
              }
 consume();
            }
            else {
              if ( (LA(1)==DOUBLE) ) {
                zzmatch(DOUBLE);
                if ( !guessing ) {
                _retv = tsDOUBLE;
                }
 consume();
              }
              else {
                if ( (LA(1)==SIGNED)
 ) {
                  zzmatch(SIGNED);
                  if ( !guessing ) {
                  _retv = tsSIGNED;
                  }
 consume();
                }
                else {
                  if ( (LA(1)==UNSIGNED) ) {
                    zzmatch(UNSIGNED);
                    if ( !guessing ) {
                    _retv = tsUNSIGNED;
                    }
 consume();
                  }
                  else {
                    if ( (setwd4[LA(1)]&0x10) ) {
                      if ( !guessing ) {
                         _retv  = struct_or_union_specifier();

                      } else {
                        struct_or_union_specifier();
                      }
                    }
                    else {
                      if ( (LA(1)==ENUM) ) {
                        enum_specifier();
                        if ( !guessing ) {
                        _retv = tsENUM;
                        }
                      }
                      else {
                        if ( (LA(1)==IDENTIFIER) ) {
                          typeID();
                          if ( !guessing ) {
                          _retv = tsTYPEID;
                          }
                        }
                        else {FAIL(1,err13,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  }
  return _retv;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd4, 0x20);
  return _retv;
}

void
CParser::typeID(void)
{
  zzRULE;
  if (!(isTypeName(LT(1)->getText()))    ) {zzfailed_pred("  isTypeName(LT(1)->getText())",0 /* report */, { 0; /* no user action */ } );}
  zzmatch(IDENTIFIER); consume();
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd4, 0x40);
}

CParser::TypeQualifier
CParser::type_qualifier(void)
{
  CParser::TypeQualifier   _retv;
  zzRULE;
  PCCTS_PURIFY(_retv,sizeof(CParser::TypeQualifier  ))
  if ( (LA(1)==CONST)
 ) {
    zzmatch(CONST);
    if ( !guessing ) {
    _retv = tqCONST;
    }
 consume();
  }
  else {
    if ( (LA(1)==VOLATILE) ) {
      zzmatch(VOLATILE);
      if ( !guessing ) {
      _retv = tqVOLATILE;
      }
 consume();
    }
    else {FAIL(1,err14,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
  }
  return _retv;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd4, 0x80);
  return _retv;
}

CParser::TypeSpecifier
CParser::struct_or_union_specifier(void)
{
  CParser::TypeSpecifier   _retv;
  zzRULE;
  ANTLRTokenPtr id=NULL;
  PCCTS_PURIFY(_retv,sizeof(CParser::TypeSpecifier  ))
  {
    if ( (LA(1)==STRUCT) ) {
      zzmatch(STRUCT);
      if ( !guessing ) {
      _retv=tsSTRUCT;
      }
 consume();
    }
    else {
      if ( (LA(1)==UNION) ) {
        zzmatch(UNION);
        if ( !guessing ) {
        _retv=tsUNION;
        }
 consume();
      }
      else {FAIL(1,err15,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
    }
  }
  {
    if ( (LA(1)==IDENTIFIER) && (setwd5[LA(2)]&0x1) ) {
      zzmatch(IDENTIFIER); consume();
    }
    else {
      if ( (LA(1)==IDENTIFIER) && 
(LA(2)==LCURLYBRACE) ) {
        zzmatch(IDENTIFIER);
        if ( !guessing ) {
                id = (ANTLRTokenPtr)LT(1);
        }
         consume();
        zzmatch(LCURLYBRACE);
        if ( !guessing ) {
        beginAggrDefinition(_retv,  id->getText());
        }
 consume();
        {
          int zzcnt=1;
          do {
            struct_declaration();
          } while ( (setwd5[LA(1)]&0x2) );
        }
        if ( !guessing ) {
        endAggrDefinition();
        }
        zzmatch(RCURLYBRACE); consume();
      }
      else {
        if ( (LA(1)==LCURLYBRACE) ) {
          zzmatch(LCURLYBRACE);
          if ( !guessing ) {
          beginAggrDefinition(_retv, "anonymous");
          }
 consume();
          {
            int zzcnt=1;
            do {
              struct_declaration();
            } while ( (setwd5[LA(1)]&0x4) );
          }
          if ( !guessing ) {
          endAggrDefinition();
          }
          zzmatch(RCURLYBRACE); consume();
        }
        else {FAIL(2,err16,err17,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
      }
    }
  }
  return _retv;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd5, 0x8);
  return _retv;
}

void
CParser::init_declarator_list(void)
{
  zzRULE;
  init_declarator();
  {
    while ( (LA(1)==COMMA) ) {
      zzmatch(COMMA); consume();
      init_declarator();
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd5, 0x10);
}

void
CParser::init_declarator(void)
{
  zzRULE;
  declarator();
  {
    if ( (LA(1)==ASSIGNEQUAL)
 ) {
      zzmatch(ASSIGNEQUAL); consume();
      initializer();
    }
    else {
      if ( (setwd5[LA(1)]&0x20) ) {
      }
      else {FAIL(1,err18,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd5, 0x40);
}

void
CParser::struct_declaration(void)
{
  zzRULE;
  ;
  if ( !guessing ) {
  beginFieldDeclaration();
  }
  specifier_qualifier_list();
  struct_declarator_list();
  zzmatch(SEMICOLON);
  if ( !guessing ) {
  endFieldDeclaration();
  }
 consume();
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd5, 0x80);
}

void
CParser::specifier_qualifier_list(void)
{
  zzRULE;
  TypeSpecifier ts=tsINVALID, ts2; TypeQualifier tq=tqINVALID, tq2;
  {
    int zzcnt=1;
    do {
      if ( (setwd6[LA(1)]&0x1) && (setwd6[LA(2)]&0x2)&&(!(((LA(1)==IDENTIFIER)))||(isTypeName(LT(1)->getText()))) ) {
        if ( !guessing ) {
           ts2  = type_specifier();

        } else {
          type_specifier();
        }
        if ( !guessing ) {
        ts=checkTypeSpecifier(ts, ts2, LT(1));
        }
      }
      else {
        if ( (setwd6[LA(1)]&0x4) ) {
          if ( !guessing ) {
             tq2  = type_qualifier();

          } else {
            type_qualifier();
          }
          if ( !guessing ) {
          if (tq&tq2) synError("multiple type qualifier", LT(1)); else tq=TypeQualifier(tq|tq2);
          }
        }
        /* MR10 ()+ */ else {
          if ( zzcnt > 1 ) break;
          else {FAIL(2,err19,err20,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
        }
      }
      zzcnt++;
    } while ( 1 );
  }
  if ( !guessing ) {
  declarationSpecifier(scINVALID, tq, ts);
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd6, 0x8);
}

void
CParser::struct_declarator_list(void)
{
  zzRULE;
  struct_declarator();
  {
    while ( (LA(1)==COMMA)
 ) {
      zzmatch(COMMA); consume();
      struct_declarator();
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd6, 0x10);
}

void
CParser::struct_declarator(void)
{
  zzRULE;
  if ( (setwd6[LA(1)]&0x20) ) {
    declarator();
    {
      if ( (LA(1)==COLON) ) {
        zzmatch(COLON); consume();
        constant_expression();
      }
      else {
        if ( (setwd6[LA(1)]&0x40) ) {
        }
        else {FAIL(1,err21,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
      }
    }
  }
  else {
    if ( (LA(1)==COLON) ) {
      zzmatch(COLON); consume();
      constant_expression();
    }
    else {FAIL(1,err22,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd6, 0x80);
}

void
CParser::enum_specifier(void)
{
  zzRULE;
  zzmatch(ENUM); consume();
  {
    if ( (LA(1)==IDENTIFIER)
 ) {
      zzmatch(IDENTIFIER); consume();
      {
        if ( (LA(1)==LCURLYBRACE) ) {
          zzmatch(LCURLYBRACE); consume();
          enumerator_list();
          zzmatch(RCURLYBRACE); consume();
        }
        else {
          if ( (setwd7[LA(1)]&0x1) ) {
          }
          else {FAIL(1,err23,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
        }
      }
    }
    else {
      if ( (LA(1)==LCURLYBRACE) ) {
        zzmatch(LCURLYBRACE); consume();
        enumerator_list();
        zzmatch(RCURLYBRACE); consume();
      }
      else {FAIL(1,err24,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd7, 0x2);
}

void
CParser::enumerator_list(void)
{
  zzRULE;
  enumerator();
  {
    while ( (LA(1)==COMMA) ) {
      zzmatch(COMMA); consume();
      enumerator();
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd7, 0x4);
}

void
CParser::enumerator(void)
{
  zzRULE;
  zzmatch(IDENTIFIER); consume();
  {
    if ( (LA(1)==ASSIGNEQUAL)
 ) {
      zzmatch(ASSIGNEQUAL); consume();
      constant_expression();
    }
    else {
      if ( (setwd7[LA(1)]&0x8) ) {
      }
      else {FAIL(1,err25,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd7, 0x10);
}

void
CParser::declarator(void)
{
  zzRULE;
  TypeQualifier tq;
  if ( (LA(1)==STAR) ) {
    if ( !guessing ) {
       tq  = pointer();

    } else {
      pointer();
    }
    declarator();
    if ( !guessing ) {
    declaratorPointerTo(tq);
    }
  }
  else {
    if ( (setwd7[LA(1)]&0x20) ) {
      direct_declarator();
    }
    else {FAIL(1,err26,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd7, 0x40);
}

CParser::TypeQualifier
CParser::pointer(void)
{
  CParser::TypeQualifier   _retv;
  zzRULE;
  PCCTS_PURIFY(_retv,sizeof(CParser::TypeQualifier  ))
  TypeQualifier tq2;
  if ( !guessing ) {
  _retv=tqINVALID;
  }
  zzmatch(STAR); consume();
  {
    while ( (setwd7[LA(1)]&0x80) ) {
      if ( !guessing ) {
         tq2  = type_qualifier();

      } else {
        type_qualifier();
      }
      if ( !guessing ) {
      if (_retv&tq2) synError("multiple type qualifier", LT(1)); else _retv=TypeQualifier(_retv|tq2);
      }
    }
  }
  return _retv;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd8, 0x1);
  return _retv;
}

void
CParser::direct_declarator(void)
{
  zzRULE;
  ANTLRTokenPtr id=NULL;
  if ( (LA(1)==IDENTIFIER)
 ) {
    zzmatch(IDENTIFIER);
    if ( !guessing ) {
        id = (ANTLRTokenPtr)LT(1);
    }
    
    if ( !guessing ) {
    declaratorID( id->getText());
    }
 consume();
    {
      while ( (setwd8[LA(1)]&0x2) ) {
        declarator_suffix();
      }
    }
  }
  else {
    if ( (LA(1)==LPARENTHESIS) ) {
      zzmatch(LPARENTHESIS); consume();
      declarator();
      zzmatch(RPARENTHESIS); consume();
      {
        while ( (setwd8[LA(1)]&0x4) ) {
          declarator_suffix();
        }
      }
    }
    else {FAIL(1,err27,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd8, 0x8);
}

void
CParser::declarator_suffix(void)
{
  zzRULE;
  if ( (LA(1)==LSQUAREBRACKET) ) {
    zzmatch(LSQUAREBRACKET); consume();
    {
      if ( (setwd8[LA(1)]&0x10)
 ) {
        constant_expression();
      }
      else {
        if ( (LA(1)==RSQUAREBRACKET) ) {
        }
        else {FAIL(1,err28,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
      }
    }
    zzmatch(RSQUAREBRACKET);
    if ( !guessing ) {
    declaratorArray();
    }
 consume();
  }
  else {
    if ( (LA(1)==LPARENTHESIS) ) {
      zzmatch(LPARENTHESIS);
      if ( !guessing ) {
      declaratorParameterList();
      }
 consume();
      {
        if ( (LA(1)==IDENTIFIER) && (setwd8[LA(2)]&0x20)&&(!(((LA(1)==IDENTIFIER)))||(!isTypeName(LT(1)->getText()))) ) {
          if (!(!isTypeName(LT(1)->getText()))            ) {zzfailed_pred("  !isTypeName(LT(1)->getText())",0 /* report */, { 0; /* no user action */ } );}
          identifier_list();
        }
        else {
          if ( (setwd8[LA(1)]&0x40) && 
(setwd8[LA(2)]&0x80) ) {
            parameter_list();
          }
          else {
            if ( (LA(1)==RPARENTHESIS) ) {
            }
            else {FAIL(2,err29,err30,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
          }
        }
      }
      zzmatch(RPARENTHESIS);
      if ( !guessing ) {
      declaratorEndParameterList();
      }
 consume();
    }
    else {FAIL(1,err31,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd9, 0x1);
}

void
CParser::parameter_list(void)
{
  zzRULE;
  parameter_declaration_list();
  {
    if ( (LA(1)==COMMA) ) {
      zzmatch(COMMA); consume();
      zzmatch(ELLIPSIS); consume();
    }
    else {
      if ( (LA(1)==RPARENTHESIS) ) {
      }
      else {FAIL(1,err32,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd9, 0x2);
}

void
CParser::parameter_declaration_list(void)
{
  zzRULE;
  parameter_declaration();
  {
    while ( (LA(1)==COMMA) && (setwd9[LA(2)]&0x4) ) {
      zzmatch(COMMA); consume();
      parameter_declaration();
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd9, 0x8);
}

void
CParser::parameter_declaration(void)
{
  zzRULE;
  ;
  if ( !guessing ) {
  beginParameterDeclaration();
  }
  declaration_specifiers();
  {
    zzGUESS_BLOCK
    zzGUESS
    if ( !zzrv && (setwd9[LA(1)]&0x10) && 
(setwd9[LA(2)]&0x20) ) {
      {
        declarator();
      }
      zzGUESS_DONE
      {
        declarator();
      }
    }
    else {
      if ( !zzrv ) zzGUESS_DONE;
      if ( (setwd9[LA(1)]&0x40) && (setwd9[LA(2)]&0x80) ) {
        abstract_declarator();
      }
      else {FAIL(2,err33,err34,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
    }
  }
  if ( !guessing ) {
  endParameterDeclaration();
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd10, 0x1);
}

void
CParser::identifier_list(void)
{
  zzRULE;
  zzmatch(IDENTIFIER); consume();
  {
    while ( (LA(1)==COMMA) ) {
      zzmatch(COMMA); consume();
      zzmatch(IDENTIFIER); consume();
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd10, 0x2);
}

void
CParser::initializer(void)
{
  zzRULE;
  if ( (setwd10[LA(1)]&0x4) ) {
    assignment_expression();
  }
  else {
    if ( (LA(1)==LCURLYBRACE) ) {
      zzmatch(LCURLYBRACE); consume();
      initializer();
      {
        while ( (LA(1)==COMMA) && 
(setwd10[LA(2)]&0x8) ) {
          zzmatch(COMMA); consume();
          initializer();
        }
      }
      {
        if ( (LA(1)==COMMA) ) {
          zzmatch(COMMA); consume();
        }
        else {
          if ( (LA(1)==RCURLYBRACE) ) {
          }
          else {FAIL(1,err35,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
        }
      }
      zzmatch(RCURLYBRACE); consume();
    }
    else {FAIL(1,err36,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd10, 0x10);
}

void
CParser::type_name(void)
{
  zzRULE;
  specifier_qualifier_list();
  abstract_declarator();
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd10, 0x20);
}

void
CParser::abstract_declarator(void)
{
  zzRULE;
  TypeQualifier tq;
  if ( (LA(1)==STAR) ) {
    if ( !guessing ) {
       tq  = pointer();

    } else {
      pointer();
    }
    abstract_declarator();
    if ( !guessing ) {
    declaratorPointerTo(tq);
    }
  }
  else {
    if ( (LA(1)==LPARENTHESIS) ) {
      zzmatch(LPARENTHESIS); consume();
      abstract_declarator();
      zzmatch(RPARENTHESIS); consume();
      {
        int zzcnt=1;
        do {
          abstract_declarator_suffix();
        } while ( (setwd10[LA(1)]&0x40)
 );
      }
    }
    else {
      if ( (LA(1)==LSQUAREBRACKET) ) {
        {
          int zzcnt=1;
          do {
            zzmatch(LSQUAREBRACKET); consume();
            {
              if ( (setwd10[LA(1)]&0x80) ) {
                constant_expression();
              }
              else {
                if ( (LA(1)==RSQUAREBRACKET) ) {
                }
                else {FAIL(1,err37,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
              }
            }
            zzmatch(RSQUAREBRACKET);
            if ( !guessing ) {
            declaratorArray();
            }
 consume();
          } while ( (LA(1)==LSQUAREBRACKET) );
        }
      }
      else {
        if ( (setwd11[LA(1)]&0x1)
 ) {
        }
        else {FAIL(1,err38,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
      }
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd11, 0x2);
}

void
CParser::abstract_declarator_suffix(void)
{
  zzRULE;
  if ( (LA(1)==LSQUAREBRACKET) ) {
    zzmatch(LSQUAREBRACKET); consume();
    {
      if ( (setwd11[LA(1)]&0x4) ) {
        constant_expression();
      }
      else {
        if ( (LA(1)==RSQUAREBRACKET) ) {
        }
        else {FAIL(1,err39,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
      }
    }
    zzmatch(RSQUAREBRACKET);
    if ( !guessing ) {
    declaratorArray();
    }
 consume();
  }
  else {
    if ( (LA(1)==LPARENTHESIS) ) {
      zzmatch(LPARENTHESIS);
      if ( !guessing ) {
      declaratorParameterList();
      }
 consume();
      {
        if ( (setwd11[LA(1)]&0x8)
 ) {
          parameter_list();
        }
        else {
          if ( (LA(1)==RPARENTHESIS) ) {
          }
          else {FAIL(1,err40,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
        }
      }
      zzmatch(RPARENTHESIS);
      if ( !guessing ) {
      declaratorEndParameterList();
      }
 consume();
    }
    else {FAIL(1,err41,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd11, 0x10);
}

void
CParser::statement_list(void)
{
  zzRULE;
  {
    int zzcnt=1;
    do {
      statement();
    } while ( (setwd11[LA(1)]&0x20) );
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd11, 0x40);
}

void
CParser::statement(void)
{
  zzRULE;
  if ( (LA(1)==IDENTIFIER) && (LA(2)==COLON) ) {
    plain_label_statement();
  }
  else {
    if ( (setwd11[LA(1)]&0x80) ) {
      case_label_statement();
    }
    else {
      if ( (setwd12[LA(1)]&0x1) && 
(setwd12[LA(2)]&0x2) ) {
        expression();
        zzmatch(SEMICOLON); consume();
      }
      else {
        if ( (LA(1)==LCURLYBRACE) ) {
          compound_statement();
        }
        else {
          if ( (setwd12[LA(1)]&0x4) ) {
            selection_statement();
          }
          else {
            if ( (setwd12[LA(1)]&0x8) ) {
              iteration_statement();
            }
            else {
              if ( (setwd12[LA(1)]&0x10) ) {
                jump_statement();
              }
              else {
                if ( (LA(1)==SEMICOLON)
 ) {
                  zzmatch(SEMICOLON); consume();
                }
                else {FAIL(2,err42,err43,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
              }
            }
          }
        }
      }
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd12, 0x20);
}

void
CParser::plain_label_statement(void)
{
  zzRULE;
  zzmatch(IDENTIFIER); consume();
  zzmatch(COLON); consume();
  statement();
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd12, 0x40);
}

void
CParser::case_label_statement(void)
{
  zzRULE;
  if ( (LA(1)==CASE) ) {
    zzmatch(CASE); consume();
    constant_expression();
    zzmatch(COLON); consume();
    statement();
  }
  else {
    if ( (LA(1)==DEFAULT) ) {
      zzmatch(DEFAULT); consume();
      zzmatch(COLON); consume();
      statement();
    }
    else {FAIL(1,err44,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd12, 0x80);
}

void
CParser::compound_statement(void)
{
  zzRULE;
  zzmatch(LCURLYBRACE);
  if ( !guessing ) {
  enterNewLocalScope();
  }
 consume();
  {
    while ( (setwd13[LA(1)]&0x1) && (setwd13[LA(2)]&0x2)&&(!(((LA(1)==IDENTIFIER)))||(isTypeName(LT(1)->getText()))) ) {
      declaration();
    }
  }
  {
    if ( (setwd13[LA(1)]&0x4)
 ) {
      statement_list();
    }
    else {
      if ( (LA(1)==RCURLYBRACE) ) {
      }
      else {FAIL(1,err45,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
    }
  }
  zzmatch(RCURLYBRACE);
  if ( !guessing ) {
  exitLocalScope();
  }
 consume();
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd13, 0x8);
}

void
CParser::selection_statement(void)
{
  zzRULE;
  if ( (LA(1)==IF) ) {
    zzmatch(IF); consume();
    zzmatch(LPARENTHESIS); consume();
    expression();
    zzmatch(RPARENTHESIS); consume();
    statement();
    {
      if ( (LA(1)==ELSE) && (setwd13[LA(2)]&0x10) ) {
        zzmatch(ELSE); consume();
        statement();
      }
      else {
        if ( (setwd13[LA(1)]&0x20) && (setwd13[LA(2)]&0x40) ) {
        }
        else {FAIL(2,err46,err47,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
      }
    }
  }
  else {
    if ( (LA(1)==SWITCH)
 ) {
      zzmatch(SWITCH); consume();
      zzmatch(LPARENTHESIS); consume();
      expression();
      zzmatch(RPARENTHESIS); consume();
      statement();
    }
    else {FAIL(1,err48,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd13, 0x80);
}

void
CParser::iteration_statement(void)
{
  zzRULE;
  if ( (LA(1)==WHILE) ) {
    zzmatch(WHILE); consume();
    zzmatch(LPARENTHESIS); consume();
    expression();
    zzmatch(RPARENTHESIS); consume();
    statement();
  }
  else {
    if ( (LA(1)==DO) ) {
      zzmatch(DO); consume();
      statement();
      zzmatch(WHILE); consume();
      zzmatch(LPARENTHESIS); consume();
      expression();
      zzmatch(RPARENTHESIS); consume();
      zzmatch(SEMICOLON); consume();
    }
    else {
      if ( (LA(1)==FOR) ) {
        zzmatch(FOR); consume();
        zzmatch(LPARENTHESIS); consume();
        {
          if ( (setwd14[LA(1)]&0x1) ) {
            expression();
          }
          else {
            if ( (LA(1)==SEMICOLON)
 ) {
            }
            else {FAIL(1,err49,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
          }
        }
        zzmatch(SEMICOLON); consume();
        {
          if ( (setwd14[LA(1)]&0x2) ) {
            expression();
          }
          else {
            if ( (LA(1)==SEMICOLON) ) {
            }
            else {FAIL(1,err50,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
          }
        }
        zzmatch(SEMICOLON); consume();
        {
          if ( (setwd14[LA(1)]&0x4) ) {
            expression();
          }
          else {
            if ( (LA(1)==RPARENTHESIS) ) {
            }
            else {FAIL(1,err51,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
          }
        }
        zzmatch(RPARENTHESIS); consume();
        statement();
      }
      else {FAIL(1,err52,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd14, 0x8);
}

void
CParser::jump_statement(void)
{
  zzRULE;
  if ( (LA(1)==GOTO)
 ) {
    zzmatch(GOTO); consume();
    zzmatch(IDENTIFIER); consume();
    zzmatch(SEMICOLON); consume();
  }
  else {
    if ( (LA(1)==CONTINUE) ) {
      zzmatch(CONTINUE); consume();
      zzmatch(SEMICOLON); consume();
    }
    else {
      if ( (LA(1)==BREAK) ) {
        zzmatch(BREAK); consume();
        zzmatch(SEMICOLON); consume();
      }
      else {
        if ( (LA(1)==RETURN) ) {
          zzmatch(RETURN); consume();
          {
            if ( (setwd14[LA(1)]&0x10) ) {
              expression();
            }
            else {
              if ( (LA(1)==SEMICOLON)
 ) {
              }
              else {FAIL(1,err53,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
            }
          }
          zzmatch(SEMICOLON); consume();
        }
        else {FAIL(1,err54,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
      }
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd14, 0x20);
}

void
CParser::expression(void)
{
  zzRULE;
  assignment_expression();
  {
    while ( (LA(1)==COMMA) ) {
      zzmatch(COMMA); consume();
      assignment_expression();
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd14, 0x40);
}

void
CParser::assignment_expression(void)
{
  zzRULE;
  zzGUESS_BLOCK
  zzGUESS
  if ( !zzrv && (setwd14[LA(1)]&0x80) && (setwd15[LA(2)]&0x1) ) {
    {
      unary_expression();
      {
        if ( (LA(1)==ASSIGNEQUAL) ) {
          zzmatch(ASSIGNEQUAL); consume();
        }
        else {
          if ( (LA(1)==TIMESEQUAL) ) {
            zzmatch(TIMESEQUAL); consume();
          }
          else {
            if ( (LA(1)==DIVIDEEQUAL)
 ) {
              zzmatch(DIVIDEEQUAL); consume();
            }
            else {
              if ( (LA(1)==MODEQUAL) ) {
                zzmatch(MODEQUAL); consume();
              }
              else {
                if ( (LA(1)==PLUSEQUAL) ) {
                  zzmatch(PLUSEQUAL); consume();
                }
                else {
                  if ( (LA(1)==MINUSEQUAL) ) {
                    zzmatch(MINUSEQUAL); consume();
                  }
                  else {
                    if ( (LA(1)==SHIFTLEFTEQUAL) ) {
                      zzmatch(SHIFTLEFTEQUAL); consume();
                    }
                    else {
                      if ( (LA(1)==SHIFTRIGHTEQUAL)
 ) {
                        zzmatch(SHIFTRIGHTEQUAL); consume();
                      }
                      else {
                        if ( (LA(1)==BITWISEANDEQUAL) ) {
                          zzmatch(BITWISEANDEQUAL); consume();
                        }
                        else {
                          if ( (LA(1)==BITWISEXOREQUAL) ) {
                            zzmatch(BITWISEXOREQUAL); consume();
                          }
                          else {
                            if ( (LA(1)==BITWISEOREQUAL) ) {
                              zzmatch(BITWISEOREQUAL); consume();
                            }
                            else {FAIL(1,err55,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
      assignment_expression();
    }
    zzGUESS_DONE
    {
      unary_expression();
      {
        if ( (LA(1)==ASSIGNEQUAL) ) {
          zzmatch(ASSIGNEQUAL); consume();
        }
        else {
          if ( (LA(1)==TIMESEQUAL)
 ) {
            zzmatch(TIMESEQUAL); consume();
          }
          else {
            if ( (LA(1)==DIVIDEEQUAL) ) {
              zzmatch(DIVIDEEQUAL); consume();
            }
            else {
              if ( (LA(1)==MODEQUAL) ) {
                zzmatch(MODEQUAL); consume();
              }
              else {
                if ( (LA(1)==PLUSEQUAL) ) {
                  zzmatch(PLUSEQUAL); consume();
                }
                else {
                  if ( (LA(1)==MINUSEQUAL) ) {
                    zzmatch(MINUSEQUAL); consume();
                  }
                  else {
                    if ( (LA(1)==SHIFTLEFTEQUAL)
 ) {
                      zzmatch(SHIFTLEFTEQUAL); consume();
                    }
                    else {
                      if ( (LA(1)==SHIFTRIGHTEQUAL) ) {
                        zzmatch(SHIFTRIGHTEQUAL); consume();
                      }
                      else {
                        if ( (LA(1)==BITWISEANDEQUAL) ) {
                          zzmatch(BITWISEANDEQUAL); consume();
                        }
                        else {
                          if ( (LA(1)==BITWISEXOREQUAL) ) {
                            zzmatch(BITWISEXOREQUAL); consume();
                          }
                          else {
                            if ( (LA(1)==BITWISEOREQUAL) ) {
                              zzmatch(BITWISEOREQUAL); consume();
                            }
                            else {FAIL(1,err56,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
      assignment_expression();
    }
  }
  else {
    if ( !zzrv ) zzGUESS_DONE;
    if ( (setwd15[LA(1)]&0x2) && 
(setwd15[LA(2)]&0x4) ) {
      conditional_expression();
    }
    else {FAIL(2,err57,err58,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd15, 0x8);
}

void
CParser::conditional_expression(void)
{
  zzRULE;
  logical_or_expression();
  {
    if ( (LA(1)==QUESTIONMARK) ) {
      zzmatch(QUESTIONMARK); consume();
      expression();
      zzmatch(COLON); consume();
      conditional_expression();
    }
    else {
      if ( (setwd15[LA(1)]&0x10) ) {
      }
      else {FAIL(1,err59,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd15, 0x20);
}

void
CParser::constant_expression(void)
{
  zzRULE;
  conditional_expression();
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd15, 0x40);
}

void
CParser::logical_or_expression(void)
{
  zzRULE;
  logical_and_expression();
  {
    while ( (LA(1)==OR) ) {
      zzmatch(OR); consume();
      logical_and_expression();
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd15, 0x80);
}

void
CParser::logical_and_expression(void)
{
  zzRULE;
  inclusive_or_expression();
  {
    while ( (LA(1)==AND) ) {
      zzmatch(AND); consume();
      inclusive_or_expression();
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd16, 0x1);
}

void
CParser::inclusive_or_expression(void)
{
  zzRULE;
  exclusive_or_expression();
  {
    while ( (LA(1)==BITWISEOR)
 ) {
      zzmatch(BITWISEOR); consume();
      exclusive_or_expression();
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd16, 0x2);
}

void
CParser::exclusive_or_expression(void)
{
  zzRULE;
  and_expression();
  {
    while ( (LA(1)==BITWISEXOR) ) {
      zzmatch(BITWISEXOR); consume();
      and_expression();
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd16, 0x4);
}

void
CParser::and_expression(void)
{
  zzRULE;
  equality_expression();
  {
    while ( (LA(1)==AMPERSAND) ) {
      zzmatch(AMPERSAND); consume();
      equality_expression();
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd16, 0x8);
}

void
CParser::equality_expression(void)
{
  zzRULE;
  relational_expression();
  {
    while ( (setwd16[LA(1)]&0x10) ) {
      {
        if ( (LA(1)==NOTEQUAL) ) {
          zzmatch(NOTEQUAL); consume();
        }
        else {
          if ( (LA(1)==EQUAL)
 ) {
            zzmatch(EQUAL); consume();
          }
          else {FAIL(1,err60,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
        }
      }
      relational_expression();
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd16, 0x20);
}

void
CParser::relational_expression(void)
{
  zzRULE;
  shift_expression();
  {
    while ( (setwd16[LA(1)]&0x40) ) {
      {
        if ( (LA(1)==LESSTHAN) ) {
          zzmatch(LESSTHAN); consume();
        }
        else {
          if ( (LA(1)==GREATERTHAN) ) {
            zzmatch(GREATERTHAN); consume();
          }
          else {
            if ( (LA(1)==LESSTHANOREQUALTO) ) {
              zzmatch(LESSTHANOREQUALTO); consume();
            }
            else {
              if ( (LA(1)==GREATERTHANOREQUALTO)
 ) {
                zzmatch(GREATERTHANOREQUALTO); consume();
              }
              else {FAIL(1,err61,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
            }
          }
        }
      }
      shift_expression();
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd16, 0x80);
}

void
CParser::shift_expression(void)
{
  zzRULE;
  additive_expression();
  {
    while ( (setwd17[LA(1)]&0x1) ) {
      {
        if ( (LA(1)==SHIFTLEFT) ) {
          zzmatch(SHIFTLEFT); consume();
        }
        else {
          if ( (LA(1)==SHIFTRIGHT) ) {
            zzmatch(SHIFTRIGHT); consume();
          }
          else {FAIL(1,err62,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
        }
      }
      additive_expression();
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd17, 0x2);
}

void
CParser::additive_expression(void)
{
  zzRULE;
  multiplicative_expression();
  {
    while ( (setwd17[LA(1)]&0x4) ) {
      {
        if ( (LA(1)==PLUS)
 ) {
          zzmatch(PLUS); consume();
        }
        else {
          if ( (LA(1)==MINUS) ) {
            zzmatch(MINUS); consume();
          }
          else {FAIL(1,err63,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
        }
      }
      multiplicative_expression();
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd17, 0x8);
}

void
CParser::multiplicative_expression(void)
{
  zzRULE;
  cast_expression();
  {
    while ( (setwd17[LA(1)]&0x10) ) {
      {
        if ( (LA(1)==STAR) ) {
          zzmatch(STAR); consume();
        }
        else {
          if ( (LA(1)==DIVIDE) ) {
            zzmatch(DIVIDE); consume();
          }
          else {
            if ( (LA(1)==MOD)
 ) {
              zzmatch(MOD); consume();
            }
            else {FAIL(1,err64,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
          }
        }
      }
      cast_expression();
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd17, 0x20);
}

void
CParser::cast_expression(void)
{
  zzRULE;
  if ( (LA(1)==LPARENTHESIS) && (setwd17[LA(2)]&0x40)&&(!(( LA(1)==LPARENTHESIS && LA(2)==IDENTIFIER))||(isTypeName(LT(2)->getText()))) ) {
    if (!(!(( LA(1)==LPARENTHESIS && LA(2)==IDENTIFIER))||(isTypeName(LT(2)->getText())))      ) {zzfailed_pred("  isTypeName(LT(2)->getText())",0 /* report */, { 0; /* no user action */ } );}
    zzmatch(LPARENTHESIS); consume();
    type_name();
    zzmatch(RPARENTHESIS); consume();
    cast_expression();
  }
  else {
    if ( (setwd17[LA(1)]&0x80) && (setwd18[LA(2)]&0x1) ) {
      unary_expression();
    }
    else {FAIL(2,err65,err66,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd18, 0x2);
}

void
CParser::unary_expression(void)
{
  zzRULE;
  if ( (setwd18[LA(1)]&0x4) ) {
    postfix_expression();
  }
  else {
    if ( (LA(1)==PLUSPLUS) ) {
      zzmatch(PLUSPLUS); consume();
      unary_expression();
    }
    else {
      if ( (LA(1)==MINUSMINUS)
 ) {
        zzmatch(MINUSMINUS); consume();
        unary_expression();
      }
      else {
        if ( (setwd18[LA(1)]&0x8) ) {
          unary_operator();
          cast_expression();
        }
        else {
          if ( (LA(1)==SIZEOF) ) {
            zzmatch(SIZEOF); consume();
            {
              if ( (LA(1)==LPARENTHESIS) && (setwd18[LA(2)]&0x10)&&(!(( LA(1)==LPARENTHESIS && LA(2)==IDENTIFIER))||(isTypeName(LT(2)->getText()))) ) {
                if (!(!(( LA(1)==LPARENTHESIS && LA(2)==IDENTIFIER))||(isTypeName(LT(2)->getText())))                  ) {zzfailed_pred("  isTypeName(LT(2)->getText())",0 /* report */, { 0; /* no user action */ } );}
                zzmatch(LPARENTHESIS); consume();
                type_name();
                zzmatch(RPARENTHESIS); consume();
              }
              else {
                if ( (setwd18[LA(1)]&0x20) && (setwd18[LA(2)]&0x40) ) {
                  unary_expression();
                }
                else {FAIL(2,err67,err68,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
              }
            }
          }
          else {FAIL(1,err69,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
        }
      }
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd18, 0x80);
}

void
CParser::unary_operator(void)
{
  zzRULE;
  if ( (LA(1)==AMPERSAND)
 ) {
    zzmatch(AMPERSAND); consume();
  }
  else {
    if ( (LA(1)==STAR) ) {
      zzmatch(STAR); consume();
    }
    else {
      if ( (LA(1)==PLUS) ) {
        zzmatch(PLUS); consume();
      }
      else {
        if ( (LA(1)==MINUS) ) {
          zzmatch(MINUS); consume();
        }
        else {
          if ( (LA(1)==ONESCOMPLEMENT) ) {
            zzmatch(ONESCOMPLEMENT); consume();
          }
          else {
            if ( (LA(1)==NOT)
 ) {
              zzmatch(NOT); consume();
            }
            else {FAIL(1,err70,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
          }
        }
      }
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd19, 0x1);
}

void
CParser::postfix_expression(void)
{
  zzRULE;
  primary_expression();
  {
    for (;;) {
      if ( !((setwd19[LA(1)]&0x2))) break;
      if ( (LA(1)==LSQUAREBRACKET) ) {
        zzmatch(LSQUAREBRACKET); consume();
        expression();
        zzmatch(RSQUAREBRACKET); consume();
      }
      else {
        if ( (LA(1)==LPARENTHESIS) ) {
          zzmatch(LPARENTHESIS); consume();
          {
            if ( (setwd19[LA(1)]&0x4) ) {
              argument_expression_list();
            }
            else {
              if ( (LA(1)==RPARENTHESIS)
 ) {
              }
              else {FAIL(1,err71,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
            }
          }
          zzmatch(RPARENTHESIS); consume();
        }
        else {
          if ( (LA(1)==DOT) ) {
            zzmatch(DOT); consume();
            zzmatch(IDENTIFIER); consume();
          }
          else {
            if ( (LA(1)==POINTERTO) ) {
              zzmatch(POINTERTO); consume();
              zzmatch(IDENTIFIER); consume();
            }
            else {
              if ( (LA(1)==PLUSPLUS) ) {
                zzmatch(PLUSPLUS); consume();
              }
              else {
                if ( (LA(1)==MINUSMINUS) ) {
                  zzmatch(MINUSMINUS); consume();
                }
                else break; /* MR6 code for exiting loop "for sure" */
              }
            }
          }
        }
      }
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd19, 0x8);
}

void
CParser::primary_expression(void)
{
  zzRULE;
  if ( (LA(1)==IDENTIFIER)
 ) {
    zzmatch(IDENTIFIER); consume();
  }
  else {
    if ( (setwd19[LA(1)]&0x10) ) {
      constant();
    }
    else {
      if ( (LA(1)==STRING) ) {
        {
          int zzcnt=1;
          do {
            zzmatch(STRING); consume();
          } while ( (LA(1)==STRING) );
        }
      }
      else {
        if ( (LA(1)==LPARENTHESIS) ) {
          zzmatch(LPARENTHESIS); consume();
          expression();
          zzmatch(RPARENTHESIS); consume();
        }
        else {FAIL(1,err72,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
      }
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd19, 0x20);
}

void
CParser::argument_expression_list(void)
{
  zzRULE;
  assignment_expression();
  {
    while ( (LA(1)==COMMA)
 ) {
      zzmatch(COMMA); consume();
      assignment_expression();
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd19, 0x40);
}

void
CParser::constant(void)
{
  zzRULE;
  if ( (LA(1)==OCTALINT) ) {
    zzmatch(OCTALINT); consume();
  }
  else {
    if ( (LA(1)==DECIMALINT) ) {
      zzmatch(DECIMALINT); consume();
    }
    else {
      if ( (LA(1)==HEXADECIMALINT) ) {
        zzmatch(HEXADECIMALINT); consume();
      }
      else {
        if ( (LA(1)==CHARACTER) ) {
          zzmatch(CHARACTER); consume();
        }
        else {
          if ( (LA(1)==FLOATONE)
 ) {
            zzmatch(FLOATONE); consume();
          }
          else {
            if ( (LA(1)==FLOATTWO) ) {
              zzmatch(FLOATTWO); consume();
            }
            else {FAIL(1,err73,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
          }
        }
      }
    }
  }
  return;
fail:
  if ( guessing ) zzGUESS_FAIL;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd19, 0x80);
}
