/*
 * CParser: P a r s e r  H e a d e r 
 *
 * Generated from: ansi.g
 *
 * Terence Parr, Russell Quong, Will Cohen, and Hank Dietz: 1989-2001
 * Parr Research Corporation
 * with Purdue University Electrical Engineering
 * with AHPCRC, University of Minnesota
 * ANTLR Version 1.33MR29
 */

#ifndef CParser_h
#define CParser_h

#ifndef ANTLR_VERSION
#define ANTLR_VERSION 13329
#endif

#include "AParser.h"


#include "CDictionary.h"

#ifdef WIN32
#pragma warning(disable:4102) /* Unreferced labels */
#endif

  
class CParser : public ANTLRParser {
public:
	static  const ANTLRChar *tokenName(int tk);
	enum { SET_SIZE = 132 };
protected:
	static const ANTLRChar *_token_tbl[];
private:

public:
enum TypeSpecifier {
  tsINVALID=0, tsVOID=0x1, tsCHAR=0x2, tsSHORT=0x4,
  tsINT=0x8, tsLONG=0x10, tsFLOAT=0x20,
  tsDOUBLE=0x40, tsSIGNED=0x80, tsUNSIGNED=0x100,
  tsTYPEID=0x200, tsSTRUCT=0x400, tsENUM=0x800, tsUNION=0x1000
};

	enum TypeQualifier { tqINVALID=0, tqCONST=1, tqVOLATILE };

	enum StorageClass {
  scINVALID=0, scAUTO=1, scREGISTER,
  scSTATIC, scEXTERN, scTYPEDEF
};
private:
// MK: check whether this combination of type specifiers is valid
TypeSpecifier checkTypeSpecifier(TypeSpecifier ts, TypeSpecifier add,
_ANTLRTokenPtr tok);

protected:
// Symbol table management stuff
CDictionary *symbols;
StorageClass _sc;
TypeQualifier _tq;
TypeSpecifier _ts;
unsigned char functionDefinition;

public:
void init()
{
  ANTLRParser::init();
  symbols = new CDictionary(101, 200);
  functionDefinition=0; // MK: fix uninitialized bug
  traceOptionValueDefault=0;  // sets reset value
  traceOption(-1);            // sets current value
}

protected:
// Semantic interface; subclass and redefine these functions
// so you don't have to mess with the grammar itself.

	virtual int isTypeName(char *s);
virtual void enterNewLocalScope();
virtual void exitLocalScope();
virtual void enterExternalScope();
virtual void exitExternalScope();

	// Declaration stuff
virtual void beginDeclaration();
virtual void endDeclaration();
virtual void beginFunctionDefinition();
virtual void endFunctionDefinition();
virtual void beginParameterDeclaration();
virtual void endParameterDeclaration(); // MK: added for symmetry
virtual void beginFieldDeclaration();
virtual void endFieldDeclaration(); // MK: added for symmetry
virtual void declarationSpecifier(StorageClass,
TypeQualifier,
TypeSpecifier);

	virtual void beginAggrDefinition(TypeSpecifier, char *);
virtual void endAggrDefinition();

	// Declarator stuff
// MK: added cv-qualified pointers
virtual void declaratorPointerTo(TypeQualifier);
virtual void declaratorID(char *);
virtual void declaratorArray();
virtual void declaratorParameterList();
virtual void declaratorEndParameterList();

	virtual void panic(char *);
virtual void synError(char *, _ANTLRTokenPtr);
protected:
	static SetWordType err1[20];
	static SetWordType err2[20];
	static SetWordType setwd1[132];
	static SetWordType err3[20];
	static SetWordType err4[20];
	static SetWordType err5[20];
	static SetWordType err6[20];
	static SetWordType err7[20];
	static SetWordType setwd2[132];
	static SetWordType err8[20];
	static SetWordType err9[20];
	static SetWordType setwd3[132];
	static SetWordType err10[20];
	static SetWordType err11[20];
	static SetWordType err12[20];
	static SetWordType err13[20];
	static SetWordType err14[20];
	static SetWordType err15[20];
	static SetWordType setwd4[132];
	static SetWordType err16[20];
	static SetWordType err17[20];
	static SetWordType err18[20];
	static SetWordType setwd5[132];
	static SetWordType err19[20];
	static SetWordType err20[20];
	static SetWordType err21[20];
	static SetWordType err22[20];
	static SetWordType setwd6[132];
	static SetWordType err23[20];
	static SetWordType err24[20];
	static SetWordType err25[20];
	static SetWordType err26[20];
	static SetWordType setwd7[132];
	static SetWordType err27[20];
	static SetWordType err28[20];
	static SetWordType err29[20];
	static SetWordType err30[20];
	static SetWordType err31[20];
	static SetWordType setwd8[132];
	static SetWordType err32[20];
	static SetWordType err33[20];
	static SetWordType err34[20];
	static SetWordType setwd9[132];
	static SetWordType err35[20];
	static SetWordType err36[20];
	static SetWordType err37[20];
	static SetWordType setwd10[132];
	static SetWordType err38[20];
	static SetWordType err39[20];
	static SetWordType err40[20];
	static SetWordType err41[20];
	static SetWordType setwd11[132];
	static SetWordType err42[20];
	static SetWordType err43[20];
	static SetWordType err44[20];
	static SetWordType setwd12[132];
	static SetWordType err45[20];
	static SetWordType err46[20];
	static SetWordType err47[20];
	static SetWordType err48[20];
	static SetWordType setwd13[132];
	static SetWordType err49[20];
	static SetWordType err50[20];
	static SetWordType err51[20];
	static SetWordType err52[20];
	static SetWordType err53[20];
	static SetWordType err54[20];
	static SetWordType setwd14[132];
	static SetWordType err55[20];
	static SetWordType err56[20];
	static SetWordType err57[20];
	static SetWordType err58[20];
	static SetWordType err59[20];
	static SetWordType setwd15[132];
	static SetWordType err60[20];
	static SetWordType err61[20];
	static SetWordType setwd16[132];
	static SetWordType err62[20];
	static SetWordType err63[20];
	static SetWordType err64[20];
	static SetWordType setwd17[132];
	static SetWordType err65[20];
	static SetWordType err66[20];
	static SetWordType err67[20];
	static SetWordType err68[20];
	static SetWordType err69[20];
	static SetWordType err70[20];
	static SetWordType setwd18[132];
	static SetWordType err71[20];
	static SetWordType err72[20];
	static SetWordType err73[20];
	static SetWordType setwd19[132];
private:
	void zzdflthandlers( int _signal, int *_retsignal );

public:
	CParser(ANTLRTokenBuffer *input);
	void translation_unit(void);
	void external_declaration(void);
	void function_definition(void);
	void declaration(void);
	void declaration_list(void);
	void declaration_specifiers(void);
	CParser::StorageClass storage_class_specifier(void);
	CParser::TypeSpecifier type_specifier(void);
	void typeID(void);
	CParser::TypeQualifier type_qualifier(void);
	CParser::TypeSpecifier struct_or_union_specifier(void);
	void init_declarator_list(void);
	void init_declarator(void);
	void struct_declaration(void);
	void specifier_qualifier_list(void);
	void struct_declarator_list(void);
	void struct_declarator(void);
	void enum_specifier(void);
	void enumerator_list(void);
	void enumerator(void);
	void declarator(void);
	CParser::TypeQualifier pointer(void);
	void direct_declarator(void);
	void declarator_suffix(void);
	void parameter_list(void);
	void parameter_declaration_list(void);
	void parameter_declaration(void);
	void identifier_list(void);
	void initializer(void);
	void type_name(void);
	void abstract_declarator(void);
	void abstract_declarator_suffix(void);
	void statement_list(void);
	void statement(void);
	void plain_label_statement(void);
	void case_label_statement(void);
	void compound_statement(void);
	void selection_statement(void);
	void iteration_statement(void);
	void jump_statement(void);
	void expression(void);
	void assignment_expression(void);
	void conditional_expression(void);
	void constant_expression(void);
	void logical_or_expression(void);
	void logical_and_expression(void);
	void inclusive_or_expression(void);
	void exclusive_or_expression(void);
	void and_expression(void);
	void equality_expression(void);
	void relational_expression(void);
	void shift_expression(void);
	void additive_expression(void);
	void multiplicative_expression(void);
	void cast_expression(void);
	void unary_expression(void);
	void unary_operator(void);
	void postfix_expression(void);
	void primary_expression(void);
	void argument_expression_list(void);
	void constant(void);
};

#endif /* CParser_h */
