#ifndef DLGLexer_h
#define DLGLexer_h
/*
 * D L G L e x e r  C l a s s  D e f i n i t i o n
 *
 * Generated from: parser.dlg
 *
 * 1989-2001 by  Will Cohen, Terence Parr, and Hank Dietz
 * Purdue University Electrical Engineering
 * DLG Version 1.33MR29
 */


#include "DLexerBase.h"

class DLGLexer : public DLGLexerBase {
public:
public:
	static const int MAX_MODE;
	static const int DfaStates;
	static const int START;
	static const int COMMENT;
	static const int STRINGS;
	static const int CHARACTERS;
	static const int DONE;
	typedef unsigned short DfaState;

	DLGLexer(DLGInputStream *in,
		unsigned bufsize=2000)
		: DLGLexerBase(in, bufsize, 1)
	{
	;
	}
	void	  mode(int);
	ANTLRTokenType nextTokenType(void);
	void     advance(void);
protected:
	ANTLRTokenType act1();
	ANTLRTokenType act2();
	ANTLRTokenType act3();
	ANTLRTokenType act4();
	ANTLRTokenType act5();
	ANTLRTokenType act6();
	ANTLRTokenType act7();
	ANTLRTokenType act8();
	ANTLRTokenType act9();
	ANTLRTokenType act10();
	ANTLRTokenType act11();
	ANTLRTokenType act12();
	ANTLRTokenType act13();
	ANTLRTokenType act14();
	ANTLRTokenType act15();
	ANTLRTokenType act16();
	ANTLRTokenType act17();
	ANTLRTokenType act18();
	ANTLRTokenType act19();
	ANTLRTokenType act20();
	ANTLRTokenType act21();
	ANTLRTokenType act22();
	ANTLRTokenType act23();
	ANTLRTokenType act24();
	ANTLRTokenType act25();
	ANTLRTokenType act26();
	ANTLRTokenType act27();
	ANTLRTokenType act28();
	ANTLRTokenType act29();
	ANTLRTokenType act30();
	ANTLRTokenType act31();
	ANTLRTokenType act32();
	ANTLRTokenType act33();
	ANTLRTokenType act34();
	ANTLRTokenType act35();
	ANTLRTokenType act36();
	ANTLRTokenType act37();
	ANTLRTokenType act38();
	ANTLRTokenType act39();
	ANTLRTokenType act40();
	ANTLRTokenType act41();
	ANTLRTokenType act42();
	ANTLRTokenType act43();
	ANTLRTokenType act44();
	ANTLRTokenType act45();
	ANTLRTokenType act46();
	ANTLRTokenType act47();
	ANTLRTokenType act48();
	ANTLRTokenType act49();
	ANTLRTokenType act50();
	ANTLRTokenType act51();
	ANTLRTokenType act52();
	ANTLRTokenType act53();
	ANTLRTokenType act54();
	ANTLRTokenType act55();
	ANTLRTokenType act56();
	ANTLRTokenType act57();
	ANTLRTokenType act58();
	ANTLRTokenType act59();
	ANTLRTokenType act60();
	ANTLRTokenType act61();
	ANTLRTokenType act62();
	ANTLRTokenType act63();
	ANTLRTokenType act64();
	ANTLRTokenType act65();
	ANTLRTokenType act66();
	ANTLRTokenType act67();
	ANTLRTokenType act68();
	ANTLRTokenType act69();
	ANTLRTokenType act70();
	ANTLRTokenType act71();
	ANTLRTokenType act72();
	ANTLRTokenType act73();
	ANTLRTokenType act74();
	ANTLRTokenType act75();
	ANTLRTokenType act76();
	ANTLRTokenType act77();
	ANTLRTokenType act78();
	ANTLRTokenType act79();
	ANTLRTokenType act80();
	ANTLRTokenType act81();
	ANTLRTokenType act82();
	ANTLRTokenType act83();
	ANTLRTokenType act84();
	ANTLRTokenType act85();
	ANTLRTokenType act86();
	ANTLRTokenType act87();
	ANTLRTokenType act88();
	ANTLRTokenType act89();
	ANTLRTokenType act90();
	ANTLRTokenType act91();
	ANTLRTokenType act92();
	ANTLRTokenType act93();
	ANTLRTokenType act94();
	ANTLRTokenType act95();
	ANTLRTokenType act96();
	ANTLRTokenType act97();
	ANTLRTokenType act98();
	ANTLRTokenType act99();
	ANTLRTokenType act100();
	ANTLRTokenType act101();
	ANTLRTokenType act102();
	ANTLRTokenType act103();
	ANTLRTokenType act104();
	ANTLRTokenType act105();
	ANTLRTokenType act106();
	ANTLRTokenType act107();
	ANTLRTokenType act108();
	ANTLRTokenType act109();
	ANTLRTokenType act110();
	ANTLRTokenType act111();
	ANTLRTokenType act112();
	ANTLRTokenType act113();
	ANTLRTokenType act114();
	ANTLRTokenType act115();
	ANTLRTokenType act116();
	ANTLRTokenType act117();
	ANTLRTokenType act118();
	ANTLRTokenType act119();
	ANTLRTokenType act120();
	ANTLRTokenType act121();
	ANTLRTokenType act122();
	ANTLRTokenType act123();
	ANTLRTokenType act124();
	ANTLRTokenType act125();
	ANTLRTokenType act126();
	ANTLRTokenType act127();
	ANTLRTokenType act128();
	ANTLRTokenType act129();
	ANTLRTokenType act130();
	ANTLRTokenType act131();
	ANTLRTokenType act132();
	ANTLRTokenType act133();
	ANTLRTokenType act134();
	ANTLRTokenType act135();
	ANTLRTokenType act136();
	static DfaState st0[68];
	static DfaState st1[68];
	static DfaState st2[68];
	static DfaState st3[68];
	static DfaState st4[68];
	static DfaState st5[68];
	static DfaState st6[68];
	static DfaState st7[68];
	static DfaState st8[68];
	static DfaState st9[68];
	static DfaState st10[68];
	static DfaState st11[68];
	static DfaState st12[68];
	static DfaState st13[68];
	static DfaState st14[68];
	static DfaState st15[68];
	static DfaState st16[68];
	static DfaState st17[68];
	static DfaState st18[68];
	static DfaState st19[68];
	static DfaState st20[68];
	static DfaState st21[68];
	static DfaState st22[68];
	static DfaState st23[68];
	static DfaState st24[68];
	static DfaState st25[68];
	static DfaState st26[68];
	static DfaState st27[68];
	static DfaState st28[68];
	static DfaState st29[68];
	static DfaState st30[68];
	static DfaState st31[68];
	static DfaState st32[68];
	static DfaState st33[68];
	static DfaState st34[68];
	static DfaState st35[68];
	static DfaState st36[68];
	static DfaState st37[68];
	static DfaState st38[68];
	static DfaState st39[68];
	static DfaState st40[68];
	static DfaState st41[68];
	static DfaState st42[68];
	static DfaState st43[68];
	static DfaState st44[68];
	static DfaState st45[68];
	static DfaState st46[68];
	static DfaState st47[68];
	static DfaState st48[68];
	static DfaState st49[68];
	static DfaState st50[68];
	static DfaState st51[68];
	static DfaState st52[68];
	static DfaState st53[68];
	static DfaState st54[68];
	static DfaState st55[68];
	static DfaState st56[68];
	static DfaState st57[68];
	static DfaState st58[68];
	static DfaState st59[68];
	static DfaState st60[68];
	static DfaState st61[68];
	static DfaState st62[68];
	static DfaState st63[68];
	static DfaState st64[68];
	static DfaState st65[68];
	static DfaState st66[68];
	static DfaState st67[68];
	static DfaState st68[68];
	static DfaState st69[68];
	static DfaState st70[68];
	static DfaState st71[68];
	static DfaState st72[68];
	static DfaState st73[68];
	static DfaState st74[68];
	static DfaState st75[68];
	static DfaState st76[68];
	static DfaState st77[68];
	static DfaState st78[68];
	static DfaState st79[68];
	static DfaState st80[68];
	static DfaState st81[68];
	static DfaState st82[68];
	static DfaState st83[68];
	static DfaState st84[68];
	static DfaState st85[68];
	static DfaState st86[68];
	static DfaState st87[68];
	static DfaState st88[68];
	static DfaState st89[68];
	static DfaState st90[68];
	static DfaState st91[68];
	static DfaState st92[68];
	static DfaState st93[68];
	static DfaState st94[68];
	static DfaState st95[68];
	static DfaState st96[68];
	static DfaState st97[68];
	static DfaState st98[68];
	static DfaState st99[68];
	static DfaState st100[68];
	static DfaState st101[68];
	static DfaState st102[68];
	static DfaState st103[68];
	static DfaState st104[68];
	static DfaState st105[68];
	static DfaState st106[68];
	static DfaState st107[68];
	static DfaState st108[68];
	static DfaState st109[68];
	static DfaState st110[68];
	static DfaState st111[68];
	static DfaState st112[68];
	static DfaState st113[68];
	static DfaState st114[68];
	static DfaState st115[68];
	static DfaState st116[68];
	static DfaState st117[68];
	static DfaState st118[68];
	static DfaState st119[68];
	static DfaState st120[68];
	static DfaState st121[68];
	static DfaState st122[68];
	static DfaState st123[68];
	static DfaState st124[68];
	static DfaState st125[68];
	static DfaState st126[68];
	static DfaState st127[68];
	static DfaState st128[68];
	static DfaState st129[68];
	static DfaState st130[68];
	static DfaState st131[68];
	static DfaState st132[68];
	static DfaState st133[68];
	static DfaState st134[68];
	static DfaState st135[68];
	static DfaState st136[68];
	static DfaState st137[68];
	static DfaState st138[68];
	static DfaState st139[68];
	static DfaState st140[68];
	static DfaState st141[68];
	static DfaState st142[68];
	static DfaState st143[68];
	static DfaState st144[68];
	static DfaState st145[68];
	static DfaState st146[68];
	static DfaState st147[68];
	static DfaState st148[68];
	static DfaState st149[68];
	static DfaState st150[68];
	static DfaState st151[68];
	static DfaState st152[68];
	static DfaState st153[68];
	static DfaState st154[68];
	static DfaState st155[68];
	static DfaState st156[68];
	static DfaState st157[68];
	static DfaState st158[68];
	static DfaState st159[68];
	static DfaState st160[68];
	static DfaState st161[68];
	static DfaState st162[68];
	static DfaState st163[68];
	static DfaState st164[68];
	static DfaState st165[68];
	static DfaState st166[68];
	static DfaState st167[68];
	static DfaState st168[68];
	static DfaState st169[68];
	static DfaState st170[68];
	static DfaState st171[68];
	static DfaState st172[68];
	static DfaState st173[68];
	static DfaState st174[68];
	static DfaState st175[68];
	static DfaState st176[68];
	static DfaState st177[68];
	static DfaState st178[68];
	static DfaState st179[68];
	static DfaState st180[68];
	static DfaState st181[68];
	static DfaState st182[68];
	static DfaState st183[68];
	static DfaState st184[68];
	static DfaState st185[68];
	static DfaState st186[68];
	static DfaState st187[68];
	static DfaState st188[68];
	static DfaState st189[68];
	static DfaState st190[68];
	static DfaState st191[68];
	static DfaState st192[68];
	static DfaState st193[68];
	static DfaState st194[68];
	static DfaState st195[68];
	static DfaState st196[68];
	static DfaState st197[68];
	static DfaState st198[68];
	static DfaState st199[68];
	static DfaState st200[68];
	static DfaState st201[68];
	static DfaState st202[68];
	static DfaState st203[68];
	static DfaState st204[68];
	static DfaState st205[68];
	static DfaState st206[68];
	static DfaState st207[68];
	static DfaState st208[68];
	static DfaState st209[68];
	static DfaState st210[68];
	static DfaState st211[68];
	static DfaState st212[68];
	static DfaState st213[68];
	static DfaState st214[68];
	static DfaState st215[68];
	static DfaState st216[68];
	static DfaState st217[68];
	static DfaState st218[68];
	static DfaState st219[68];
	static DfaState st220[68];
	static DfaState st221[68];
	static DfaState st222[68];
	static DfaState st223[68];
	static DfaState st224[68];
	static DfaState st225[68];
	static DfaState st226[68];
	static DfaState st227[68];
	static DfaState st228[68];
	static DfaState st229[68];
	static DfaState st230[68];
	static DfaState st231[68];
	static DfaState st232[68];
	static DfaState st233[6];
	static DfaState st234[6];
	static DfaState st235[6];
	static DfaState st236[6];
	static DfaState st237[6];
	static DfaState st238[6];
	static DfaState st239[21];
	static DfaState st240[21];
	static DfaState st241[21];
	static DfaState st242[21];
	static DfaState st243[21];
	static DfaState st244[21];
	static DfaState st245[21];
	static DfaState st246[21];
	static DfaState st247[21];
	static DfaState st248[21];
	static DfaState st249[21];
	static DfaState st250[21];
	static DfaState st251[21];
	static DfaState st252[21];
	static DfaState st253[21];
	static DfaState st254[21];
	static DfaState st255[21];
	static DfaState st256[21];
	static DfaState st257[21];
	static DfaState st258[21];
	static DfaState st259[21];
	static DfaState st260[21];
	static DfaState st261[21];
	static DfaState st262[21];
	static DfaState st263[21];
	static DfaState st264[21];
	static DfaState st265[21];
	static DfaState st266[21];
	static DfaState st267[21];
	static DfaState st268[21];
	static DfaState st269[21];
	static DfaState st270[21];
	static DfaState st271[21];
	static DfaState st272[21];
	static DfaState st273[21];
	static DfaState st274[21];
	static DfaState st275[21];
	static DfaState st276[21];
	static DfaState st277[21];
	static DfaState st278[21];
	static DfaState st279[21];
	static DfaState st280[21];
	static DfaState st281[21];
	static DfaState st282[21];
	static DfaState st283[21];
	static DfaState st284[21];
	static DfaState st285[21];
	static DfaState st286[21];
	static DfaState st287[3];
	static DfaState st288[3];
	static DfaState st289[3];
	static DfaState *dfa[290];
	static DfaState dfa_base[];
	static unsigned char *b_class_no[];
	static DfaState accepts[291];
	static DLGChar alternatives[291];
	static ANTLRTokenType (DLGLexer::*actions[137])();
	static unsigned char shift0[257];
	static unsigned char shift1[257];
	static unsigned char shift2[257];
	static unsigned char shift3[257];
	static unsigned char shift4[257];
	int ZZSHIFT(int c) { return b_class_no[automaton][1+c]; }
//
// 133MR1 Deprecated feature to allow inclusion of user-defined code in DLG class header
//
#ifdef DLGLexerIncludeFile
#include DLGLexerIncludeFile
#endif
};
typedef ANTLRTokenType (DLGLexer::*PtrDLGLexerMemberFunc)();
#endif
